from collections.abc import Awaitable, Callable, Sequence
from typing import Any

from temporalio import workflow

from csirtmu.beta_temporal.commons.actions import MattermostActions
from csirtmu.beta_temporal.commons.actions.temporal_common_actions import TemporalCommonActions
from csirtmu.beta_temporal.commons.conditions import CommonConditions
from csirtmu.beta_temporal.config import AppConfig
from csirtmu.beta_temporal.constants import WorkflowReference
from csirtmu.beta_temporal.external_services.mattermost.client import MattermostClient
from csirtmu.beta_temporal.external_services.rt import structs
from csirtmu.beta_temporal.external_services.rt.client import RTClient
from csirtmu.beta_temporal.workflows.logging import LoggedWorkflow


class MattermostNotificationOnAnalyticsCategory(
    LoggedWorkflow, workflow_name=WorkflowReference.MATTERMOST_NOTIFICATION_ON_ANALYTICS_CATEGORY
):
    @classmethod
    def get_activities(cls) -> Sequence[Callable[..., Awaitable[Any]]]:
        config = AppConfig.get()
        common_conditions = CommonConditions(RTClient(config.rt))
        mm_actions = MattermostActions(config.rt.base_url, MattermostClient(config.mattermost))
        temporal_actions = TemporalCommonActions(config.temporal)
        return [*common_conditions.get_activities(), *mm_actions.get_activities(), *temporal_actions.get_activities()]

    @workflow.run
    async def run(self, transaction: structs.TransactionStruct, params: dict[str, str]) -> None:
        self.log_workflow()
        config = AppConfig.get()
        if not (channel := params.get("mm_channel")):
            raise ValueError("No channel given!")
        if await workflow.execute_activity(
            CommonConditions.custom_field_value_set,
            args=("Category", "Analytics", transaction),
            retry_policy=config.temporal.retry_policy,
            start_to_close_timeout=config.temporal.activity_timeout,
        ):
            await workflow.execute_activity(
                MattermostActions.notify_mattermost_on_analytics_category,
                args=(
                    transaction,
                    channel,
                ),
                retry_policy=config.temporal.retry_policy,
                start_to_close_timeout=config.temporal.activity_timeout,
            )
        elif config.temporal.allow_internal_cancels:
            await workflow.execute_activity(
                TemporalCommonActions.cancel_workflow,
                args=(workflow.info().workflow_id, workflow.info().task_queue),
                retry_policy=config.temporal.retry_policy,
                start_to_close_timeout=config.temporal.activity_timeout,
            )
